#include "forms.h"
#include "xfmame.h"


char xmame_str[80]=XFMAME_EXEC;			// Ruta para xmame.

char game_str[30]="sectionz";			// Nombre del juego.
char sound_str[20]="-nosound";			// Opcion de sonido
char scale_str[20]="1";				// Opcion de escala


/****************************************************/

/* callbacks for form xfmame */
void cb_quit_boton(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  exit(0);

}

void cb_run_boton(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  int cpid;
  
  if ((cpid=fork())==0)
   {
     char *argv[6]={xmame_str,game_str,"-scale",scale_str,sound_str,NULL};
     execvp(xmame_str,argv);
   }  
  else 
   {
     printf("\nProceso lanzado N %d\n",cpid);
     printf("\nECODE: %d",waitpid(cpid));      
   }  
}

void cb_game_select(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  int sel=fl_get_browser(ob);
  strcpy(game_str,fl_get_browser_line(ob,sel));
  
}


void cb_xfmame_boton(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  static FD_xfmame_about *fd_xfmame_about;
  
  if (data==1)
   {  
     fd_xfmame_about = create_form_xfmame_about();
     fl_show_form(fd_xfmame_about->xfmame_about,FL_PLACE_CENTER,FL_FULLBORDER,"About XF-Mame ...");
   }
  else
   {
     fl_hide_form(fd_xfmame_about->xfmame_about);
     fl_free_form(fd_xfmame_about->xfmame_about);
   }         
}


void cb_sound_check(FL_OBJECT *ob, long data)
{
  if (fl_get_button(ob)==1) sprintf(sound_str,"-sound");
  else sprintf(sound_str,"-nosound");
}


void cb_scale_counter(FL_OBJECT *ob, long data)
{
  int c=(int)fl_get_counter_value(ob);
  sprintf(scale_str,"%d",c);
}



/************************************************************************/
